// Generated by CoffeeScript 1.9.1
var fs, misc, wrap;

module.exports = function(options, callback) {
  return wrap(arguments, function(options, callback) {
    var do_chmod, do_compare, do_stat;
    if (!options.destination) {
      return callback(Error("Missing destination: " + options.destination));
    }
    if (!options.mode) {
      return callback(Error("Missing mode: " + options.mode));
    }
    do_stat = function() {
      if (options.stat) {
        return do_compare(options.stat);
      }
      if (typeof options.log === "function") {
        options.log("Mecano `chmod`: stat \"" + options.destination + "\" [DEBUG]");
      }
      return fs.stat(options.ssh, options.destination, function(err, stat) {
        if (err) {
          return callback(err);
        }
        return do_compare(stat);
      });
    };
    do_compare = function(stat) {
      if (misc.mode.compare(stat.mode, options.mode)) {
        return callback();
      }
      if (typeof options.log === "function") {
        options.log("Mecano `chmod`: change mode from " + stat.mode + " to " + options.mode + " [INFO]");
      }
      return do_chmod();
    };
    do_chmod = function() {
      return fs.chmod(options.ssh, options.destination, options.mode, function(err) {
        return callback(err, true);
      });
    };
    return do_stat();
  });
};

fs = require('ssh2-fs');

misc = require('./misc');

wrap = require('./misc/wrap');
