// Generated by CoffeeScript 1.9.1
var fs, wrap;

module.exports = function(options, callback) {
  return wrap(arguments, function(options, callback) {
    var do_chown, do_compare, do_stat;
    if (options.destination == null) {
      return callback(Error("Missing destination option"));
    }
    if (!((options.uid != null) && (options.gid != null))) {
      return callback(Error("Missing one of uid or gid option"));
    }
    do_stat = function() {
      if (options.stat) {
        return do_compare(options.stat);
      }
      if (typeof options.log === "function") {
        options.log("Mecano `chown`: stat " + options.destination + " [DEBUG]");
      }
      return fs.stat(options.ssh, options.destination, function(err, stat) {
        if (err) {
          return callback(err);
        }
        return do_compare(stat);
      });
    };
    do_compare = function(stat) {
      if (stat.uid === options.uid && stat.gid === options.gid) {
        return callback();
      }
      if (stat.uid !== options.uid) {
        if (typeof options.log === "function") {
          options.log("Mecano `chown`: change uid from " + stat.uid + " to " + options.uid + " [INFO]");
        }
      }
      if (stat.gid !== options.gid) {
        if (typeof options.log === "function") {
          options.log("Mecano `chown`: change gid from " + stat.gid + " to " + options.gid + " [INFO]");
        }
      }
      return do_chown();
    };
    do_chown = function() {
      return fs.chown(options.ssh, options.destination, options.uid, options.gid, function(err) {
        return callback(err, true);
      });
    };
    return do_stat();
  });
};

fs = require('ssh2-fs');

wrap = require('./misc/wrap');
