// Generated by CoffeeScript 1.9.1
var each, execute, ldap_add, wrap;

module.exports = function(options, callback) {
  return wrap(arguments, function(options, callback) {
    var modified;
    modified = false;
    if (!options.user) {
      return callback(Error("Mecano `ldap_user`: required property 'user'"));
    }
    if (!Array.isArray(options.user)) {
      options.user = [options.user];
    }
    return each(options.user).on('item', function(user, callback) {
      var do_checkpass, do_end, do_ldappass, do_user;
      do_user = function() {
        var entry, k, v;
        entry = {};
        for (k in user) {
          v = user[k];
          if (k === 'userPassword') {
            continue;
          }
          entry[k] = v;
        }
        return ldap_add({
          entry: entry,
          url: options.url,
          binddn: options.binddn,
          passwd: options.passwd,
          ssh: options.ssh,
          log: options.log,
          stdout: options.stdout,
          stderr: options.stderr
        }, function(err, modified, added) {
          if (err) {
            return callback(err);
          }
          if (modified || added) {
            modified = true;
          }
          if (added) {
            return do_ldappass();
          } else {
            return do_checkpass();
          }
        });
      };
      do_checkpass = function() {
        return execute({
          cmd: "ldapsearch -H ldapi:/// -D " + user.dn + " -w " + user.userPassword + " -b '" + user.dn + "'",
          code_skipped: 1,
          ssh: options.ssh,
          log: options.log,
          stdout: options.stdout,
          stderr: options.stderr
        }, function(err, exists, stdout) {
          if (err) {
            return do_ldappass();
          } else {
            return do_end();
          }
        });
      };
      do_ldappass = function() {
        return execute({
          cmd: "ldappasswd -H " + options.url + " -D " + options.binddn + " -w " + options.passwd + " '" + user.dn + "' -s " + user.userPassword,
          ssh: options.ssh,
          log: options.log,
          stdout: options.stdout,
          stderr: options.stderr
        }, function(err) {
          if (err) {
            return callback(err);
          }
          modified = true;
          return do_end();
        });
      };
      do_end = function() {
        return callback();
      };
      return do_user();
    }).on('both', function(err) {
      return callback(err, modified);
    });
  });
};

each = require('each');

execute = require('./execute');

ldap_add = require('./ldap_add');

wrap = require('./misc/wrap');
